#!/usr/local/bin/python3
# coding:utf-8
import tweepy
import datetime
from sqlalchemy import desc
from models.database import db_session
from models.models import Schedule,Config

def auth():
    CK = Config.query.filter(Config.name == 'bot_ck').one()
    CS = Config.query.filter(Config.name == 'bot_cs').one()
    AT = Config.query.filter(Config.name == 'bot_at').one()
    AS = Config.query.filter(Config.name == 'bot_as').one()
    #Twitterオブジェクトの生成
    auth = tweepy.OAuthHandler(CK.value, CS.value)
    auth.set_access_token(AT.value, AS.value)
    api = tweepy.API(auth)

    return api

# 登録があったらついーとするモジュール
def tweet_newRegist():
    time = datetime.datetime.now()
    time_minusmin = (time - datetime.timedelta(hours=24)).strftime('%Y-%m-%d %H:%M:%S')
    # ツイート時刻がNullのレコードを取得
    records = Schedule.query.filter(Schedule.postUrl == None, Schedule.registdate > time_minusmin, Schedule.canceldate == None).all()

    for record in records:
        #ツイート内容を生成
        tweetString = "開催タイトル：" + record.title + "\n"
        tweetString += "機種："+ record.pratform +"\n"
        tweetString += str(record.startdate) + " " + str(record.starttime) + "～" + str(record.endtime) + "\n"
        tweetString += "詳細：https://maruboard.com/detail/" + str(record.id)
        #ツイート
        api = auth()
        api.update_status(tweetString)

        # DBの投稿フラグを更新
        record.postUrl = "1"
    db_session.commit()
    # セッションクローズ
    db_session.close()
 
#30分ごとにツイートするモジュール
def tweet_auto():
    #現在の時刻
    time = datetime.time()
    time_minusmin = time - datetime.timedelta(minutes=30).strftime('%Y-%m-%d')

    #DBの件数を取得
    schedules = Schedule.query.filter(Schedule.registdate > time_minusmin).all()
    scheduleCount = schedules.len()
    db_session.close()

    #ツイート内容を生成
    tweetString = "新規に開催予定が登録されました。"
    tweetString += "https://maruboard.com/newSchedule?time=" + time_minusmin

    #ツイート
    api = auth()
    api.update_status(tweetString)
    
if __name__ == "__main__":
    tweet_newRegist()