#!/usr/local/bin/python3
from sqlalchemy import create_engine
from sqlalchemy.orm import scoped_session, sessionmaker
from sqlalchemy.ext.declarative import declarative_base
from models.settings.dbSettings import database
import os

engine = create_engine(
    database,
    convert_unicode=True,
    echo=False, # Trueだと実行のたびにSQLが出力される
    pool_pre_ping=True,
)
db_session = scoped_session(sessionmaker(autocommit=False,autoflush=False,bind=engine))

Base = declarative_base()
Base.query = db_session.query_property()

def init_db():
    import models.models
    Base.metadata.create_all(bind=engine)