#!/usr/local/bin/python3
from models.database import Base
from sqlalchemy import Column, Integer, String, DateTime, Date, Time

class Schedule(Base):
    __tablename__ = "schedules"
    id = Column(Integer, primary_key=True, unique=True)
    title = Column(String(20))
    startdate = Column(Date)
    starttime = Column(String(5))
    endtime = Column(String(5))
    pratform = Column(String(20))
    keyword = Column(String(10))
    userID = Column(String)
    comment = Column(String(300))
    userUrl = Column(String)
    postUrl = Column(String)
    registdate = Column(DateTime)
    canceldate = Column(DateTime)

    def __init__(self, title=None, startdate=None, starttime=None, endtime=None, pratform=None, keyword=None, userid=None, comment=None, userurl=None, postUrl=None, registdate=None, canceldate=None):
        self.title = title
        self.startdate = startdate
        self.starttime = starttime
        self.endtime = endtime
        self.pratform = pratform
        self.keyword = keyword
        self.userID = userid
        self.comment = comment
        self.userUrl = userurl
        self.postUrl = postUrl
        self.registdate = registdate
        self.canceldate = canceldate

class User(Base):
    __tablename__ = 'users'
    id = Column(Integer, primary_key=True, unique=True)
    user_id = Column(String, unique=True)
    user_name = Column(String(15))

    def __init__(self, user_id=None, user_name=None):
        self.user_id = user_id
        self.user_name = user_name

    def __repr__(self):
        return '<Name %r>' % (self.user_name)

class Config(Base):
    __tablename__ = 'config'
    name = Column(String, primary_key=True, unique=True)
    value = Column(String)

    def __init__(self, name=None, value=None):
        self.name = name
        self.value = value